on_error, 2

if n_elements(abstractMethods) eq 0 then begin
  message, 'The abstractMethods variable must be defined!'
endif

help, calls=calls
currLevel = (strsplit(calls[0],'::',/extract))[0]
currClass = obj_class(self)
foundFlag = intarr(n_elements(abstractMethods))
missedMethod = strarr(n_elements(abstractMethods))
allPros = (routine_info(/source)).name
allFunctions = (routine_info(/func,/source)).name

for j=0,n_elements(abstractMethods)-1 do begin
  for i=0,n_elements(allPros)-1 do begin
    if strmatch(allPros[i], currClass + '::' + strupcase(abstractMethods[j])) then begin
      foundFlag[j] = 1
      break
    endif
  endfor
  if foundFlag[j] eq 0 then begin
    for i=0,n_elements(allFunctions)-1 do begin
      if  strmatch(allFunctions[i], currClass + '::' + strupcase(abstractMethods[j])) then begin
        foundFlag[j] = 1
        break
      endif
    endfor
  endif
  if foundFlag[j] eq 0 then begin
    missedMethod[j] = abstractMethods[j]
  endif
endfor

if total(foundFlag) ne n_elements(abstractMethods) then begin
  message, 'The abstracted method ' + strjoin(missedMethod, ' ') + ' was not found in the ' + currClass + ' class'
endif
