;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function smoothingObject::gensmooth, method, _extra=extra

case strlowcase(method) of
'smooth' : return, call_method('smooth', self, _extra=extra)
'median' : return, call_method('median', self, _extra=extra)
'leefilt' : return, call_method('leefilt', self, _extra=extra)
'morph_open' : return, call_method('morph_open', self, _extra=extra)
'morph_close' : return, call_method('morph_close', self, _extra=extra)
else : begin
  message,'No Match was found'
  return, -1
  end
endcase

end
 
;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function smoothingObject::morph_open, _extra=extra
;Result = MORPH_OPEN (Image, Structure [, /GRAY] [, PRESERVE_TYPE=bytearray | /UINT | /ULONG] [, VALUES=array] ) 
   
;get the data from the image object
self.oImage->getProperty, data=data

if keyword_check(extra,'STRUCTURE', extract=structure) eq 0 then begin
  newImage = morph_open(data, *self.structure, _extra=extra)
endif else begin
  newImage = morph_open(data, structure, _extra=extra)
endelse

return, newImage
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function smoothingObject::morph_close, _extra=extra
;Result = MORPH_CLOSE (Image, Structure [, /GRAY] [, PRESERVE_TYPE=bytearray | /UINT | /ULONG] [, VALUES=array] ) 
   
;get the data from the image object
self.oImage->getProperty, data=data

if keyword_check(extra,'STRUCTURE', extract=structure) eq 0 then begin
  newImage = morph_close(data, *self.structure, _extra=extra)
endif else begin
  newImage = morph_close(data, structure, _extra=extra)
endelse

return, newImage
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function smoothingObject::leefilt, _extra=extra
;Result = LEEFILT( A [, N [, Sig]] [, /DOUBLE] [, /EXACT] )   
;get the data from the image object
self.oImage->getProperty, data=data

if keyword_check(extra,'WIDTH', extract=width) eq 0 and keyword_check(extra,'sigma', extract=sigma) eq 0 then begin
  newImage = leefilt(data, self.width, self.sigma, _extra=extra)
endif else if keyword_check(extra,'WIDTH', extract=width) eq 1 and keyword_check(extra,'sigma', extract=sigma) eq 0 then begin
  newImage = leefilt(data, width, self.sigma, _extra=extra)
endif else if keyword_check(extra,'WIDTH', extract=width) eq 0 and keyword_check(extra,'sigma', extract=sigma) eq 1 then begin
  newImage = leefilt(data, self.width, sigma, _extra=extra)
endif else begin
  newImage = leefilt(data, width, sigma, _extra=extra)
endelse

return, newImage
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function smoothingObject::median, _extra=extra
;Result = MEDIAN ( Array [, Width] [, /DOUBLE] [, DIMENSION=value] [, /EVEN] )  
;get the data from the image object
self.oImage->getProperty, data=data

if keyword_check(extra,'WIDTH', extract=width) eq 0 then begin
  newImage = median(data, self.width, _extra=extra)
endif else begin
  newImage = median(data, width, _extra=extra)
endelse

return, newImage
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function smoothingObject::smooth, _extra=extra
;Result = SMOOTH( Array, Width [, /EDGE_TRUNCATE] [, MISSING=value] [, /NAN] ) 
;get the data from the image object
self.oImage->getProperty, data=data

if keyword_check(extra,'WIDTH',extract=width) eq 0 then begin
  newImage = smooth(data, self.width, _extra=extra)
endif else begin
  newImage = smooth(data, width, _extra=extra)
endelse

return, newImage
end


;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function smoothingObject::getProperty, width=width, sigma=sigma, structure=structure 

if keyword_set(structure) or arg_present(structure) then return, *self.structure
if keyword_set(sigma) or arg_present(sigma) then return, self.sigma
if keyword_set(width) or arg_present(width) then return, self.width
     
return,-1
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro smoothingObject::getProperty, _ref_extra=extra
; really cool way to get variables from the function.  
;This makes the code so much easier to maintain.

for ridx=0,n_elements(extra)-1 do begin
  kw = extra[ridx]
  (scope_varfetch(kw, /ref_extra)) = self->getProperty(_extra=kw)
endfor

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro smoothingObject::setProperty, width=width, sigma=sigma, structure=structure 

if n_elements(width) ne 0 then self.width = width
if n_elements(sigma) ne 0 then self.sigma = sigma
if n_elements(structure) ne 0 then *self.structure = structure

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro smoothingObject::cleanup

if ptr_valid(self.structure) then ptr_free, self.structure

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function smoothingObject::init, oImage, width=width, sigma=sigma, structure=structure 

if n_params() eq 0 then begin
  message,'You must pass in an image object'
  return, 0
endif

;store the image object reference
self.oImage = oImage

;check for the keywords and create defaults if they aren't there
self.width = keyword_set(width) ? width : 3
self.sigma = keyword_set(sigma) ? sigma : 5
self.structure = keyword_set(structure) ? ptr_new(structure) : ptr_new(replicate(1,3,3))

return,1
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|  

pro smoothingObject__define

void = {smoothingObject, $
        
        width : 0, $
        sigma : 0, $
        
        structure : ptr_new(),$ 

        oImage : obj_new()}
        
return & end        