function time::_overloadGreaterThan, arg1, arg2

on_error, 2

if arg1 ge arg2 then return,arg1 else return, arg2

end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function time::_overloadIsTrue
on_error, 2

if self.hour gt 0 and self.hour lt 24 and $
   self.minute gt 0 and self.minute lt 60 and $
   self.second gt 0 and self.second lt 60.0 then return, 1 $
   else return,0
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function time::_overloadEQ, arg1,arg2

if arg1.hour eq arg2.hour && arg1.minute eq arg1.minute && $
   arg1.second eq arg2.second then return,1 else return,0
   
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function time::_overloadGE, arg1,arg2

;convert to julian dates
jd1 = julday(1,1,2010,arg1.hour, arg1.minute, arg1.second)
jd2 = julday(1,1,2010,arg2.hour, arg2.minute, arg2.second)

if jd1 ge jd2 then return,1 else return,0
   
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function time::_overloadSlash, arg1,arg2
on_error, 2
message,'Not possible to divide time!'
return,''
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function time::_overloadAsterisk, arg1,arg2
on_error, 2
message,'Not possible to multiply time!'
return,''
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro time::setProperty, hour=hour, minute=minute,second=second

if n_elements(hour) ne 0 then self.hour = hour
if n_elements(minute) ne 0 then self.minute = minute
if n_elements(second) ne 0 then self.second = second

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro time::getProperty, hour=hour, minute=minute,second=second

if arg_present(hour) then hour=self.hour
if arg_present(minute) then minute=self.minute
if arg_present(second) then second=self.second

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro time::_overloadBracketsLeftSide, objRef, rightValue, isRange, sub1

on_error, 2

if isRange eq 0 then begin
  case sub1 of
  0 : self.hour = rightValue
  1 : self.minute = rightValue
  2 : self.second = rightValue
  else : message,'Subscript out of range'
  endcase
endif else begin
  ;infinite loop!
  ;self[sub1[0]:sub1[1]:sub1[2]] = rightValue
  count = 0
  for i=sub1[0],sub1[1],sub1[2] do begin
    case i of
    0 : self.hour = rightValue[count++]
    1 : self.minute = rightValue[count++]
    2 : self.second = rightValue[count++]
    else:
    endcase
  endfor
endelse  

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function time::_overloadBracketsRightSide, isRange, sub1

on_error, 2
if isRange eq 0 then begin
  case sub1 of
  0 : retval = self.hour
  1 : retval = self.minute
  2 : retval = self.second
  else : message,'Subscript out of range'
  endcase
endif else begin
  temp = [self.hour, self.minute, self.second]
  retVal = temp[sub1[0]:sub1[1]:sub1[2]]
endelse  

return,retVal
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function time::_overloadPlus, arg1, arg2

on_error,2
  
if (~obj_valid(arg1) || ~obj_isa(arg1, 'time') || $
  ~obj_valid(arg2) || ~obj_isa(arg2, 'time')) then begin
  message, 'Arguments must both be time objects.'
endif

newSecond = arg1.second + arg2.second
if newSecond ge 60.0 then begin
  newSecond = newSecond - 60.0
  addMinute = 1
endif else addMinute = 0

newMinute = arg1.minute + arg2.minute + addMinute
if newMinute ge 60 then begin
  newMinute = newMinute - 60
  addHour = 1
endif else addHour = 0

newHour = arg1.hour + arg2.hour
if newHour ge 24 then newHour = newHour - 24

return,obj_new('time',newHour, newMinute, newSecond)
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function time::_overloadMinus, arg1, arg2

on_error,2
  
if (~obj_valid(arg1) || ~obj_isa(arg1, 'time') || $
  ~obj_valid(arg2) || ~obj_isa(arg2, 'time')) then begin
  message, 'Arguments must both be time objects.'
endif

newSecond = arg1.second - arg2.second
if newSecond lt 0.0 then begin
  newSecond = newSecond + 60.0
  subtractMinute = 1
endif else subtractMinute = 0

newMinute = arg1.minute - arg2.minute - subtractMinute
if newMinute lt 0 then begin
  newMinute = newMinute + 60
  subtractHour = -1
endif else subtractHour = 0

newHour = arg1.hour - arg2.hour
if newHour lt 0 then newHour = newHour + 24

self.hour = newHour
self.minute = newMinute
self.second = newSecond

return, self
;return,obj_new('time',newHour, newMinute, newSecond)
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function time::_overloadHelp, varName
;varName is the instance variables name

return, varName + ' = ' + self._overloadPrint() + ' <ObjHeapVar' + $
    strcompress(string(obj_valid(self,/get_heap_id)),/remove) + $
    '(TIME)>'
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function time::_overloadPrint
tempString = string(self.hour,format='(i2.2)') + ':' + $
             string(self.minute,format='(i2.2)') + ':' + $
             string(self.second,format='(f05.2)')
return, tempString
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function time::Init, hour, minute,second

if n_params() ne 3 then caldat, systime(/julian),month,day,year,hour,minute,second

self.hour = hour
self.minute = minute
self.second = second

return,1
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro time__define

void = {time, $
        ;inherits IDL_OperatorOverload, $
        ;inherits IDLitComponent, $
        inherits IDL_object, $
        hour : 0, $
        minute : 0, $
        second : 0.0}

return & end        
        