pro topClass::Detach, detachlist, RECORD=rec 
  if obj_valid(self.parent) then begin 
     ;; Add to or create this object's "detached" record 
     if n_elements(rec) gt 0 && ptr_valid(rec.Detached) then $ 
        *rec.Detached=create_struct('parent',self.parent,*rec.Detached) $ 
     else rec={Object:self, Detached: ptr_new({parent: self.parent})} 
     self.parent=obj_new() 
  endif 
  ;; Stow our detached set on the list 
  if n_elements(rec) gt 0 then begin 
     if n_elements(detachlist) gt 0 then detachlist=[detachlist,rec] else 
     detachlist=[rec] 
  endif 
  if ptr_valid(self.children) then $ 
     for i=0,n_elements(*self.children)-1 do $ 
        (*self.children)[i]->Detach,detachlist 
end 


pro topClass::Reattach, detached 
  self.parent=(*detached).parent 
  ptr_free,detached 
end 


pro topClass::ReattachList, list 
  for i=0,n_elements(list)-1 do $ 
     if obj_valid(list[i].Object) && ptr_valid(list[i].Detached) $ 
     then list[i].Object->Reattach,list[i].Detached 
end 


pro topClass::Save, file, COMPRESS=comp 
  self->Detach,list             ;all our vital info is now stashed in list 
  catch, serr 
  if serr ne 0 then begin       ;it failed! 
     catch,/CANCEL 
     self->ReattachList,list 
     message,'Error Saving to File: '+file 
  endif 
  save,self,FILENAME=file,COMPRESS=comp 
  catch,/CANCEL 
  self->ReattachList, list 
end 


;Now, when you say 'obj->Save, file', it will detach 
